﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Infragistics.Windows;
using Infragistics.Controls.Charts;
using Infragistics.Windows.Editors;

namespace XamDateTimeEditorClock
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private DispatcherTimer Timer { get; set; }
        public XamMonthCalendar MyCalendar { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
            this.Unloaded += new RoutedEventHandler(MainWindow_Unloaded);
        }

        void MainWindow_Unloaded(object sender, RoutedEventArgs e)
        {
            this.Timer = null;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            this.Timer = new DispatcherTimer();
            this.Timer.Tick += OnTimerTick;
            this.Timer.Interval = TimeSpan.FromSeconds(1);
            this.Timer.Start();
        }

        private void OnTimerTick(object sender, EventArgs e)
        {
            DateTime now = DateTime.Now;

            if (MyCalendar != null)
            {
                TextBlock time = Utilities.GetDescendantFromName(MyCalendar, "time") as TextBlock;
                time.Text = now.ToString("hh:mm:ss:tt 'GMT'z");
            }            
        }

        private void calendarLoaded(object sender, RoutedEventArgs e)
        {
            MyCalendar = sender as XamMonthCalendar;
        }

        private void HourRadialGaugeNeedle_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            XamRadialGauge ny = Utilities.GetDescendantFromName(MyCalendar, "ny") as XamRadialGauge;
            ny.Scales[0].Needles[0].Value = (int)e.NewValue;
        }

        private void MinRadialGaugeNeedle_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            XamRadialGauge ny = Utilities.GetDescendantFromName(MyCalendar, "ny") as XamRadialGauge;
            ny.Scales[1].Needles[0].Value = (int)e.NewValue;
        }

        private void SecRadialGaugeNeedle_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            XamRadialGauge ny = Utilities.GetDescendantFromName(MyCalendar, "ny") as XamRadialGauge;
            ny.Scales[1].Needles[1].Value = (int)e.NewValue;
        }

        private void xamDateTimeEditor1_EditModeEnding(object sender, Infragistics.Windows.Editors.Events.EditModeEndingEventArgs e)
        {
            XamRadialGauge ny = Utilities.GetDescendantFromName(MyCalendar, "ny") as XamRadialGauge;
            if ((sender as XamDateTimeEditor).Value != null)
            {
                DateTime tmp = (DateTime)(sender as XamDateTimeEditor).Value;
                DateTime dt = new DateTime();
                if (!isAM)
                {
                    dt = new DateTime(tmp.Year, tmp.Month, tmp.Day, (int)ny.Scales[0].Needles[0].Value, (int)ny.Scales[1].Needles[0].Value, (int)ny.Scales[1].Needles[1].Value).AddHours(12);
                }
                else
                    dt = new DateTime(tmp.Year, tmp.Month, tmp.Day, (int)ny.Scales[0].Needles[0].Value, (int)ny.Scales[1].Needles[0].Value, (int)ny.Scales[1].Needles[1].Value);
                (sender as XamDateTimeEditor).Value = dt;
            }            
        }

        bool isAM = true;

        private void RadioButton_Checked(object sender, RoutedEventArgs e)
        {
            isAM = true;
        }

        private void RadioButton_Checked_1(object sender, RoutedEventArgs e)
        {
            isAM = false;
        }
    }
}
